/* --------------------------------- config.h ------------------------------- */

/* This is part of the flight simulator 'fly8'.
 * Author: Eyal Lebedinsky (eyal@ise.canberra.edu.au).
*/

/* System dependent configuration information: Microsoft WINDOWS, ms c8
 * Microsoft Windows  by Michael Taylor (miket@canb.auug.org.au)
*/

#define	INIFILE	"fly.ini"	/* name of ini file */
#define	LOGFILE	"fly.log"	/* name of log file */
#define MAC_EXT "mac"		/* binary macros file extension */
#define MAX_EXT "max"		/* text macros file extension */
#define VMD_EXT "vmd"		/* video modes file extension */
#define PRM_EXT "prm"		/* plane parameters file extension */
#define SHP_EXT "vxx"		/* object shape file extension */
#define NAV_EXT "nav"		/* nav data file extension */
#define LND_EXT "lnd"		/* landscape file extension */

#define	RTMODE	"rt"		/* fopen file mode: read  text */
#define	RBMODE	"rb"		/* fopen file mode: read  binary */
#define	WTMODE	"w"		/* fopen file mode: write text  */
#define	WBMODE	"wb"		/* fopen file mode: write binary */
#define	ATMODE	"at"		/* fopen file mode: read/write text */
#define	ABMODE	"ab"		/* fopen file mode: read/write binary */

#define PATHSEP	';'		/* path separator */

#undef FAR
#define FAR		__far
#undef NEAR
#define NEAR		__near
#undef FASTCALL
#define FASTCALL	__fastcall
#undef INLINED
#define INLINED		__inline

#ifndef C_MAIN
#define C_MAIN		Fly8Main
#endif

#undef KF_UP

#undef REFRESH
#define REFRESH		1

#define NOSTDERR

#define NEED_STRICMP
#define NEED_STRNICMP
#define NEED_STRDUP

#define HAVE_JOYSTICK

#define STRICT

#define BPTR		huge
